if(!isObject(HUD_HealthBar))
{
	// Add the GUI object.
	exec("./HealthBar.gui");
	
	PlayGUI.add(HUD_HealthBar);
	HUD_HealthBar.setVisible(false);
}

if(!isObject(HUD_HealthBarText) && isObject(HUD_HealthBar))
{
	new GuiTextCtrl(HUD_HealthBarText) 
	{
		profile = "BlockChatChannelSize0Profile";
		horizSizing = "left";
		vertSizing = "bottom";
		position = getWords(vectorAdd(HUD_HealthBar.position, "-66 -4"), 0, 1);
		extent = "58 18";
		minExtent = "8 2";
		enabled = "1";
		visible = "1";
		clipToParent = "1";
		text = "HP: 100.0%";
		maxLength = "255";
		originalExtent = "58 18";
	};
	PlayGUI.add(HUD_HealthBarText);
	HUD_HealthBarText.setVisible(false);
}

if(!isObject(HUD_HealthBarTextHP) && isObject(HUD_HealthBar))
{
	new GuiTextCtrl(HUD_HealthBarTextHP) 
	{
		profile = "BlockChatChannelSize0Profile";
		horizSizing = "left";
		vertSizing = "bottom";
		position = getWords(vectorAdd(HUD_HealthBarText.position, "0 15"), 0, 1);
		extent = "72 18";
		minExtent = "8 2";
		enabled = "1";
		visible = "1";
		clipToParent = "1";
		text = "(100.0 / 100.0)";
		maxLength = "255";
		originalExtent = "72 18";
	};
	PlayGUI.add(HUD_HealthBarTextHP);
	HUD_HealthBarTextHP.setVisible(false);
}

// This function is called when you join a server with the mod activated.
// I originally had the client send this automatically in onConnectionAccepted, but that proved to be unreliable.
function clientCmdDetectHealthBarMod()
{
	commandToServer('RegisterHealthBarMod');
}

// Client command that triggers the HP bar to be adjusted..
function clientCmdSetDamageLevel(%percent, %str)
{
	HUD_HealthBar.setHealthLevel(%percent, %str);
}

// Toggles the healthbar's visibility.
function clientCmdSetHealthBarVisible(%bool)
{
	HUD_HealthBar.setVisible(%bool);
	HUD_HealthBarText.setVisible(%bool);
	if(!%bool)
		HUD_HealthBarTextHP.setVisible(false);
}

function HUD_HealthBar::setHealthLevel(%gui, %dmgPer, %healthStr)
{
	// The client command takes the amount of damage.
	// We want to show the amount of health, so we need to invert the number.
	%percent = 1 - %dmgPer;
	
	if(%percent > 0)
	{
		%newPercent = %percent * 100;
		%hp = "HP: " @ mFloatLength(%newPercent, 1) @ "%";
		HUD_HealthBarText.setText(%hp);
		HUD_HealthBarText.extent = 6 * strLen(%hp) SPC getWord(HUD_HealthBarText.extent, 1);
		%pos = getWords(vectorAdd(HUD_HealthBar.position, -66 - (getWord(HUD_HealthBarText.extent, 0) - getWord(HUD_HealthBarText.originalExtent, 0)) @ " -4"), 0, 1);
		HUD_HealthBarText.resize(getWord(%pos, 0), getWord(%pos, 1), getWord(HUD_HealthBarText.extent, 0), getWord(HUD_HealthBarText.extent, 1));

		if(getWordCount(%healthStr) != 2)
		{
			if(%healthStr $= "I")
			{
				%hp = "(INVINCIBLE)";
				HUD_HealthBarTextHP.setText(%hp);
				HUD_HealthBarTextHP.extent = 6.4 * strLen(%hp) SPC getWord(HUD_HealthBarTextHP.extent, 1);
				%pos = getWords(vectorAdd(HUD_HealthBarText.position, -(getWord(HUD_HealthBarTextHP.extent, 0) - getWord(HUD_HealthBarTextHP.originalExtent, 0)) @ " 15"), 0, 1);
				HUD_HealthBarTextHP.resize(getWord(%pos, 0), getWord(%pos, 1), getWord(HUD_HealthBarTextHP.extent, 0), getWord(HUD_HealthBarTextHP.extent, 1));
			}
			else if(HUD_HealthBarTextHP.isVisible())
				HUD_HealthBarTextHP.setVisible(false);
		}
		else
		{
			if(!HUD_HealthBarTextHP.isVisible())
				HUD_HealthBarTextHP.setVisible(true);

			%hp = "(" @ mFloatLength(getWord(%healthStr, 0), 1) @ " / " @ mFloatLength(getWord(%healthStr, 1), 1) @ ")";
			HUD_HealthBarTextHP.setText(%hp);
			HUD_HealthBarTextHP.extent = 6 * strLen(%hp) SPC getWord(HUD_HealthBarTextHP.extent, 1);
			%pos = getWords(vectorAdd(HUD_HealthBarText.position, -(getWord(HUD_HealthBarTextHP.extent, 0) - getWord(HUD_HealthBarTextHP.originalExtent, 0)) @ " 15"), 0, 1);
			HUD_HealthBarTextHP.resize(getWord(%pos, 0), getWord(%pos, 1), getWord(HUD_HealthBarTextHP.extent, 0), getWord(HUD_HealthBarTextHP.extent, 1));
		}

		HUD_HealthMeter.setPercent(%newPercent, (%healthStr $= "I"));
	}
	else if(%percent == 0)
	{
		// As does the energy bar, if you are killed the bar goes away.
		%gui.setVisible(false);
		HUD_HealthBarText.setVisible(false);
		HUD_HealthBarTextHP.setVisible(false);
	}
}

package Healthbar_Client
{	
	// Hides the Healthbar when you leave a server.
	function disconnectedCleanup(%a)
	{
		HUD_HealthBar.setVisible(false);
		HUD_HealthBarText.setVisible(false);
		HUD_HealthBarTextHP.setVisible(false);
		HUD_HealthMeter.setPercent(100);
		
		return parent::disconnectedCleanup(%a);
	}
};
activatePackage("Healthbar_Client");

function GuiSwatchCtrl::setPercent(%this, %percent, %invincible)
{
	%tickObj = %this.dmgTickObj;

	if(%percent < 0)
		%percent = 0;
	%perc = %percent / 100;
	%this.percent = %percent;
	%max = getWord(%this.getGroup().extent - %this.getGroup().barOffset, 0);
	%max2 = getWord(%this.extent, 1);
	%main = mClampF(%max / 100 * %percent, 0, %max);

	if(%this.isHealthBar)
	{
		if(%invincible)
			%color = "0.4 0.4 0.4";
		else
		{
			if(%perc <= 1)
				%color = greenToRed(%perc);
			else
				%color = "1 1 1";
		}
		%this.extent = %main SPC %max2;
		%this.setColor(%color SPC "1");
		if(isObject(%tickObj))
		{
			cancel(%tickObj.setDamagePercentTick);
			%tickObj.setDamagePercentTick(%this);
		}
	}
	else if(%this.useBarTick)
	{
		%this.extent = %main SPC %max2;
		if(isObject(%tickObj))
		{
			cancel(%tickObj.setDamagePercentTick);
			%tickObj.setDamagePercentTick(%this);
		}
	}
	else
		%this.extent = %main SPC %max2;
}

function GuiSwatchCtrl::setDamagePercentTick(%this, %obj)
{
	if(!isObject(%this))
		return;

	if(!isObject(%obj))
		return;

	cancel(%this.setDamagePercentTick);
	%x = getWord(%this.position, 0);
	%y = getWord(%this.position, 1);

	%health = getWord(%this.extent, 0);
	%max = getWord(%this.getGroup().extent - %this.getGroup().barOffset, 0);
	%main = getWord(%obj.extent, 0);

	%this.percent = mFloor(100 / %max * %health);
	%perc = %this.percent;
	if(%main > %max)
		%main = %max;
	if(%main < 0)
		%main = 0;
	%o = mFloor(%health - %main);
	if(%o > 0)
	{
		if(%o > 52)
			%a = -10 * mClampF(%o - 52 / 2, 1, 3);
		else if(%o > 42)
			%a = -6;
		else if(%o > 24)
			%a = -4;
		else if(%o > 5)
			%a = -2;
		else
			%a = -1;
	}
	else
	{
		%this.resize(%x, %y, %main, getWord(%obj.extent, 1));
		return;
	}

	if(%health + %a > %main)
	{
		%take = %health + %a;
		%this.resize(%x, %y, %take, getWord(%obj.extent, 1));
	}
	else
	{
		%this.resize(%x, %y, %main, getWord(%obj.extent, 1));
		return;
	}

	%this.setDamagePercentTick = %this.schedule(50, setDamagePercentTick, %obj);
}

function redToGreen(%a)
{
	%r = 1;
	%g = 1;
	if(%a >= (1/2))
		%g = mAbs(%a - 1) * 2;
	if(%a < (1/2))
		%r = %a * 2;
	return %r SPC %g SPC "0";
}

function greenToRed(%a)
{
	%r = 1;
	%g = 1;
	if(%a >= (1/2))
		%r = mAbs(%a - 1) * 2;
	if(%a < (1/2))
		%g = %a * 2;
	return %r SPC %g SPC "0";
}