exec("./Support_HealthDetection.cs");

if(!$HealthBar::Init)
{
	if(isFunction(RTB_registerPref))
	{
		RTB_registerPref("Enable Health Bar", "Health Settings", "$HealthBar::Enabled", "bool", "Script_Healthbar", true, false, false, "Healthbar_UpdateMethod");
		RTB_registerPref("Minigames Only?", "Health Settings", "$HealthBar::MiniOnly", "bool", "Script_Healthbar", true, false, false, "Healthbar_UpdateMethod");
		RTB_registerPref("Mode", "Health Settings", "$HealthBar::Mode", "list Health 0 HP_Percent 1", "Script_Healthbar", 0, false, false, "Healthbar_UpdateMethod");
	}
	else if(isFunction(ORBS_registerPref))
	{
		ORBS_registerPref("Enable Health Bar", "Health Settings", "$HealthBar::Enabled", "bool", "Script_Healthbar", true, false, false, "Healthbar_UpdateMethod");
		ORBS_registerPref("Minigames Only?", "Health Settings", "$HealthBar::MiniOnly", "bool", "Script_Healthbar", true, false, false, "Healthbar_UpdateMethod");
		ORBS_registerPref("Mode", "Health Settings", "$HealthBar::Mode", "list Health 0 HP_Percent 1", "Script_Healthbar", 0, false, false, "Healthbar_UpdateMethod");
	}
	//else if(isFunction(registerBlocklandPref))
	//{
	//	registerBlocklandPref("Script_Healthbar", "Health bar", "Enable", "$HealthBar::Enabled", 1, "bool", "Healthbar_UpdateMethod", "health", 0);
	//	registerBlocklandPref("Script_Healthbar", "Health bar", "Enable", "$HealthBar::MiniOnly", 1, "bool", "Healthbar_UpdateMethod", "health", 0);
	//	registerBlocklandPref("Script_Healthbar", "Health bar", "Mode", "$HealthBar::Mode", 0, "list Health 0 HP_Percent 1", "Healthbar_UpdateMethod", "health", 0);
	//}
	else
	{
		$HealthBar::Enabled = true;
		$HealthBar::MiniOnly = true;
		$HealthBar::Mode = 0;
	}

	$HealthBar::Init = 1;
}

$HealthBar::LastUpdate["Enabled"] = $HealthBar::Enabled;
$HealthBar::LastUpdate["MiniOnly"] = $HealthBar::MiniOnly;
$HealthBar::LastUpdate["Mode"] = $HealthBar::Mode;

// Notifies server and removes all healthbars.
function Healthbar_UpdateMethod()
{
	%enabled = $HealthBar::Enabled;
	%mini = $HealthBar::MiniOnly;
	%mode = $HealthBar::Mode;

	if($HealthBar::LastUpdate["Enabled"] != %enabled)
		schedule(0, 0, "messageAll", '', "\c3+ Healthbar\c0 - The Healthbar mod is now " @ (%enabled ? "\c2Enabled" : "\c0Disabled") @ "\c3.");

	if(%enabled)
	{
		%modeText = "Unknown"; //???
		switch(%mode)
		{
			case 0:
				%modeText = "Health";

			case 1:
				%modeText = "Health and Percent";
		}

		if($HealthBar::LastUpdate["Mode"] != %mode)
			schedule(0, 0, "messageAll", '', "\c3+ Healthbar\c0 - The Healthbar mode is now \c2" @ %modeText @ "\c0.");
		if($HealthBar::LastUpdate["MiniOnly"] != %mini)
			schedule(0, 0, "messageAll", '', "\c3+ Healthbar\c0 - The Healthbar mod is now on " @ (!%mini ? "\c2All the Time" : "\c2in Minigames") @ "\c3.");
	}

	$HealthBar::LastUpdate["Enabled"] = $HealthBar::Enabled;
	$HealthBar::LastUpdate["MiniOnly"] = $HealthBar::MiniOnly;
	$HealthBar::LastUpdate["Mode"] = $HealthBar::Mode;
	
	for(%a = 0; %a < ClientGroup.getCount(); %a++)
	{
		%client = ClientGroup.getObject(%a);
		if(%client.hasHealthBar)
		{
			%player = %client.player;
			if(isObject(%player))
			{
				%canSee = ($HealthBar::Enabled && (!%enabled || isObject(%client.minigame)) ? true : false);
				
				if(%canSee)
				{
					commandToClient(%client, 'setHealthBarVisible', 1);
					%player.sendHealthData();
				}
				else
					commandToClient(%client, 'setDamageLevel', 0); //Should automatically hide itself
			}
		}
	}
}

// This gives the client a tracer when it registers the mod with the server.
// It also forces the healthbar to appear if the conditions are met.
function serverCmdRegisterHealthBarMod(%client)
{
	%client.hasHealthBar = true;
	
	// If the mod is on...
	if($HealthBar::Enabled)
	{
		// And the Client has a Player..
		%player = %client.player;
		
		if(isObject(%player))
		{
			// And Minigames Only + Client is in Minigame OR Not just minigames.
			if(!$HealthBar::MiniOnly || isObject(%client.minigame))
				%player.sendHealthData();
			else
			{
				// Hide the bar.
				commandToClient(%client, 'setHealthBarVisible', false);
				commandToClient(%client, 'setDamageLevel', 0);
			}
		}
	}
}

if(isPackage("Healthbar_Server"))
	deactivatePackage("Healthbar_Server");

package Healthbar_Server
{
	function Armor::onDisabled(%this, %obj)
	{
		if(isObject(%client = %obj.client))
			%obj.sendHealthData();

		return Parent::onDisabled(%this, %obj);
	}
	
	function Armor::onNewDatablock(%this, %obj, %b)
	{
		Parent::onNewDatablock(%this, %obj, %b);
		if($HealthBar::Enabled)
		{
			// And the client exists and has the healthbar mod...
			%client = %obj.client;
			
			if(isObject(%client) && %client.hasHealthBar)
			{
				// And Minigames Only + Client is in Minigame OR Not just minigames.
				if(!$HealthBar::MiniOnly || isObject(%client.minigame))
					%obj.sendHealthData();
			}
		}
	}

	// onDamage also handles negative integers.
	function Armor::onDamage(%this, %obj, %damage)
	{
		parent::onDamage(%this, %obj, %damage);
		
		// If the mod is on...
		if($HealthBar::Enabled)
		{
			// And the client exists and has the healthbar mod...
			%client = %obj.client;
			
			if(isObject(%client) && %client.hasHealthBar)
			{
				// And Minigames Only + Client is in Minigame OR Not just minigames.
				if(!$HealthBar::MiniOnly || isObject(%client.minigame))
					%obj.sendHealthData();
			}
		}
	}
	
	function GameConnection::onClientEnterGame(%client)
	{
		parent::onClientEnterGame(%client);
		commandToClient(%client, 'detectHealthBarMod');
	}
	
	function GameConnection::spawnPlayer(%client)
	{
		%result = parent::spawnPlayer(%client);
		
		if(%client.hasHealthBar && $HealthBar::Enabled && (!$HealthBar::MiniOnly || isObject(%client.minigame)))
		{
			%player = %client.player;
			
			if(isObject(%player))
				%player.sendHealthData();

		}
		
		return %result;
	}
	
	function Player::doOverhealDecay(%obj)
	{
		parent::doOverhealDecay(%obj);
		
		// If the mod is on...
		if($HealthBar::Enabled)
		{
			// And the client exists and has the healthbar mod...
			%client = %obj.client;
			
			if(isObject(%client) && %client.hasHealthBar)
			{
				// And Minigames Only + Client is in Minigame OR Not just minigames.
				if(!$HealthBar::MiniOnly || isObject(%client.minigame))
					%obj.sendHealthData();
			}
		}
	}
};
activatePackage("Healthbar_Server");

function GameConnection::sendHealthData(%this, %val)
{
	if(isObject(%player = %this.player))
		%player.sendHealthData(%val);
}

function Player::sendHealthData(%this, %val)
{
	if(!isObject(%client = %this.client))
		return;

	if(%this.getState() $= "dead")
	{
		commandToClient(%client, 'setDamageLevel', 0, 0);
		commandToClient(%client, 'setHealthBarVisible', false);
		return;
	}

	%max = %this.getMaxHealth();
	%curHp = %this.getHealth() + (%this.pseudoHealth + %this.tf2Overheal);
					
	%dmgPercent = %this.getHealthLevel() - (%this.pseudoHealth + %this.tf2Overheal);
	%dmgPercent /= %this.getDatablock().maxDamage;
	if($HealthBar::Mode == 1)
		%hp = mClampF(%curHp, 0, %max + (%this.pseudoHealth + %this.tf2Overheal)) SPC %max;

	if(%val) //I means they are invincible, it's not always accurate
		%hp = "I";
	
	commandToClient(%client, 'setDamageLevel', %dmgPercent, %hp);
	if(!%player.healthBarVisible)
	{
		%player.healthBarVisible = 1;
		commandToClient(%client, 'setHealthBarVisible', true);
	}
}